﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class Enemy : MonoBehaviour {
	public int size;
    public int health;
    public int speed;
    public float minY = -2;
    public float maxY = 2;

    public Rigidbody2D rigidBody;

    private Vector3 direction;

	void Start () {
        Vector3 cityCenter = BuildController.instance.CenterPosition;
        direction = (cityCenter - transform.position).normalized;

        //Debug.Log("Enemy Start");
    }
	
	void Update () {
        rigidBody.MovePosition(transform.position + direction * speed * Time.deltaTime);
	}

	void OnTriggerEnter2D(Collider2D collider) {
        if (collider.GetComponent<TileObject>() == null && collider.GetComponent<BalancePlatform>() == null) { 
            return;
        }

        BalancePlatform.Instance.EnemyCollided(new BalanceModifier(size * Mathf.RoundToInt(direction.x / Mathf.Abs(direction.x))));
		Destroy (gameObject);
        SoundManager.PlaySound("EnemyHit");
	}

	public void TakeDamage(int damage){
		health -= damage;
		if (health <= 0) {
			Destroy(gameObject);
            SoundManager.PlaySound("EnemyDead");
		}
	}
}
