﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class Projectile : MonoBehaviour {

	Transform targetTransform;
	public bool fadeflag = false;
	public SpriteRenderer sprite;
	public Rigidbody2D rigidBody;
	public float speed;
	public int damage;
	void FixedUpdate()
	{
		if (targetTransform != null) {
			rigidBody.MovePosition (Vector2.MoveTowards (transform.position, targetTransform.position, speed * Time.deltaTime));
//			//iTween.MoveTo(this.gameObject, iTween.Hash("x", 2, "easeType", "easeInOutExpo", "loopType", "pingPong", "delay", .1));
//			iTween.MoveTo(this.gameObject, targetTransform.position, Vector3.Distance(this.gameObject.transform.position, targetTransform.position)/speed);
		} else {
			if (!fadeflag)
				FadeOut ();
		}
	}

	public void FadeOut()
	{
		Debug.Log("starting tween");
		fadeflag = true;
		iTween.ValueTo( gameObject, iTween.Hash(
			"from", sprite.color.a,
			"to", 0f,
			"time", 0.5f,
			"onupdatetarget", gameObject,
			"onupdate", "tweenOnUpdateCallBack"
			//,"easetype", iTween.EaseType.easeOutQuad
			,"oncomplete" , "tweenOncomplete"
		));
	}

	void tweenOnUpdateCallBack( float newValue ){
		//Debug.Log ("Color changed to " + newValue);
		sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, newValue);
		//Debug.Log( exampleInt );
	}

	void tweenOncomplete(){
		Debug.Log("Tween complete going home");
		fadeflag = false;
		Cannon.GiveBackProjectile (this);
		//Debug.Log( exampleInt );
	}

	public void ShootAt(Transform target, int damage){
		sprite.color = new Color(sprite.color.r, sprite.color.g, sprite.color.b, 1f);
		targetTransform = target;
		fadeflag = false;
		this.damage = damage;
		//iTween.MoveTo(this.gameObject, targetTransform.position, Vector3.Distance(this.gameObject.transform.position, targetTransform.position)/speed);
		iTween.MoveTo(this.gameObject, iTween.Hash("position", targetTransform.position ,"easeType", iTween.EaseType.linear, "time", Vector3.Distance(this.gameObject.transform.position, targetTransform.position)/speed));

	}

	void OnTriggerEnter2D(Collider2D other)
	{
		if (other.gameObject.CompareTag ("Enemy")) {
			other.SendMessage("TakeDamage", damage);
			Cannon.GiveBackProjectile (this);//Destroy (gameObject);
		}
	}

//	int exampleInt = 0;
//	
//	iTween.ValueTo( gameObject, iTween.Hash(
//		"from", exampleInt,
//		"to", 100,
//		"time", 1f,
//		"onupdatetarget", gameObject,
//		"onupdate", "tweenOnUpdateCallBack",
//		"easetype", iTween.EaseType.easeOutQuad
//		)
//	               );
//	
//	void tweenOnUpdateCallBack( int newValue )
//	{
//		exampleInt = newValue;
//		Debug.Log( exampleInt );
//	}
}
