﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine.UI;
using UnityEngine;
using UnityEngine.Events;

public class ResourceManager : MonoBehaviour {
	public int gold;
	public float timepassed;
	public int timeToGetGold = 3;
	public int goldGained = 1;

	public Text goldtext;

	public static ResourceManager instance;

	public bool buildPrePlanning = false;

	public Button[] Tilebuttons;
	//public Button cannonbutton;

	public UnityEvent OnGoldChanged;


	// Use this for initialization
	void Start () {
		instance = this;
		this.timepassed = 0;
		if (!buildPrePlanning) {
			OnGoldChanged.AddListener(UpdateButtons);
		} else {
			OnGoldChanged.AddListener(BuildController.instance.RefreshSignifiers);
		}

		OnGoldChanged.Invoke ();
        ShowGold();
	}

	void UpdateButtons(){
		for (int i = 0; i < Tilebuttons.Length; i++) {
			Tilebuttons [i].interactable = haveEnoughGold (BuildController.instance.TileObjectExamples [i+1].cost);
			//Tilebuttons [1].interactable = haveEnoughGold (BuildController.instance.TileObjectExamples [2].cost);
		}

	}

	void Update()
	{
		this.timepassed += Time.deltaTime;
		if (this.timepassed >= this.timeToGetGold) {
			//this.gold+=this.goldGained;
			addGold(this.goldGained);
			this.timepassed = 0;
		}
	}
	
	public int getGold() {
		return this.gold;
	}

	public void addGold (int amount) {
		this.gold += amount;
        ShowGold();
		OnGoldChanged.Invoke ();
	}

	public bool substractGold (int amount) {
		if (this.haveEnoughGold(amount)) {
			this.gold -= amount;
			OnGoldChanged.Invoke ();
            ShowGold();
			return true;
		} else {
			OnGoldChanged.Invoke ();
            ShowGold();
            return false;
		}


	}

    private void ShowGold() {
        goldtext.text = gold.ToString();
    }

	public bool haveEnoughGold (int gold) {
		return this.gold >= gold;
	}

}
