﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Cannon : TileObject {

	public static List<Projectile> Projectiles = null;
	public float range;
	public float cooldown;
	public int damage;

	public Projectile projectile;

	float cooldownLeft;

	void Start()
	{
		cooldownLeft = cooldown;
		if (Projectiles == null) {
			Projectiles = new List<Projectile>();
			for (int i = 0; i< 20; i++) {
				Projectiles.Add (Projectile.Instantiate (projectile, transform.position, Quaternion.identity).GetComponent<Projectile> ());
			}
		}
	}
	void Update()
	{
		Collider2D[] colliders = Physics2D.OverlapCircleAll (transform.position, range);
		//Debug.Log (colliders.Length);
		Enemy closestEnemy = null;
		float distance, nearestDistance = float.MaxValue;
		if (colliders.Length > 0) {
			foreach (Collider2D enemy in colliders) {
				if (enemy.GetComponent<Enemy> () != null) {
					distance = Vector3.Distance (transform.position, enemy.transform.position);
					if (distance < nearestDistance) {
						nearestDistance = distance;
						closestEnemy = enemy.GetComponent<Enemy> ();
					}
				}
			}

			if (closestEnemy != null) {
				cooldownLeft -= Time.deltaTime;
				if (cooldownLeft <= 0) {
					Shoot (closestEnemy);
				}
			}
		}
	}

	public void OnDrawGizmos()
	{
		Gizmos.DrawWireSphere (transform.position, range);
	}

	public void Shoot(Enemy closestEnemy)
	{
		cooldownLeft = cooldown;
		projectile = GetProjectile ();//Projectile.Instantiate (projectile, transform.position, Quaternion.identity).GetComponent<Projectile> ();
		projectile.gameObject.transform.position = transform.position;
		projectile.ShootAt(closestEnemy.transform, damage);
		projectile.gameObject.SetActive (true);
        SoundManager.PlaySound("Cannon");
	}

	public Projectile GetProjectile(){
		Projectile proj;
		if (Projectiles.Count > 0) {
			proj = Projectiles [0];
			Projectiles.Remove(proj);
		} else {
			proj = Projectile.Instantiate (projectile, Vector3.zero, Quaternion.identity).GetComponent<Projectile> ();
		}
//		proj.gameObject.SetActive (true);
		return proj;
	}

	public static void GiveBackProjectile(Projectile proj){
		iTween[] tweens = proj.gameObject.GetComponents<iTween>();
		foreach (iTween tween in tweens) {
			Destroy(tween);
		}
		proj.gameObject.SetActive (false);
		Projectiles.Add (proj);
	} 
}
