﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class Wave : MonoBehaviour {

	public Vector3 direction;
	public int size;
    public float speed = 3;
	public float spawnOffest;
	// Use this for initialization
	void Start () {
        Vector3 cityCenter = BuildController.instance.CenterPosition;
        direction = transform.position.x > cityCenter.x ? Vector3.left : Vector3.right;
		GetComponent<SpriteRenderer> ().flipX = transform.position.x > cityCenter.x ? false : true;

		int offsetModifier = transform.position.x > cityCenter.x ? -1 : 1;
		transform.Translate (Vector3.right * offsetModifier * spawnOffest);
	}
	
	// Update is called once per frame
	void Update () {
		transform.Translate (direction * Time.deltaTime * speed);
	}

	void OnTriggerEnter2D(Collider2D collider)
	{
        if (collider.GetComponent<TileObject>() == null && collider.GetComponent<BalancePlatform>() == null) {
            return;
        }

        BalancePlatform.Instance.WaveCollided(new BalanceModifier(size * Mathf.RoundToInt(direction.x / Mathf.Abs(direction.x))));
//		Destroy (gameObject);
        SoundManager.PlaySound("WaveHit");
		Destroy (GetComponent<BoxCollider2D> ());
	}

	void KillWave()
	{
		Destroy (gameObject);
	}
}
